/*
 * ============================================================================
 *
 * Philipp Schubert
 *
 *    Copyright (C) 2017
 *    Software Engineering Group
 *    Heinz Nixdorf Institut
 *    University of Paderborn
 *    philipp.schubert@upb.de
 *
 * ============================================================================
 */

#include <gtest/gtest.h>
#include "MyCode.h"

// Tests factorial of 0.
TEST(FactorialTest, HandlesZeroInput) { EXPECT_EQ(1, factorial(0)); }

// Tests factorial of positive numbers.
TEST(FactorialTest, HandlesPositiveInput) {
  EXPECT_EQ(1, factorial(1));
  EXPECT_EQ(2, factorial(2));
  EXPECT_EQ(6, factorial(3));
  EXPECT_EQ(40320, factorial(8));
}

// Tests for MyType
TEST(MyTypeReturnOneTest, ReturnsOne) {
  MyType t(42);
  EXPECT_EQ(1, t.returnOne());
}

// Tests for MyType
TEST(MyTypeCtorTest, HandlesPositiveAndNegativeInput) {
  MyType t(42);
  EXPECT_EQ(42, t.getValue());
  EXPECT_EQ(13, t.getValue());
  MyType u(-13);
  EXPECT_EQ(-13, u.getValue());
}

int main(int argc, char **argv) {
  ::testing::InitGoogleTest(&argc, argv);
  return RUN_ALL_TESTS();
}
